import pandas as pd 
from util import *


if __name__ == '__main__'
    #讀取資料 'iday_kword','iday_date','iday_monthly'
    data = pd.read_csv('data_daily.csv').loc[:,['iday_kword','iday_date','iday_monthly']]

    #參數n為前後區間拉開的長度，越小越靈敏(多波峰)，用大越遲鈍(少波峰)
    #th為(前後區間內最小值/波峰)需大於門檻值th，越小越靈敏(多波峰)，用大越遲鈍(少波峰)
    n = 30
    th = 0.5
    key_word_nm = 'iday_kword'
    date_nm='iday_date'
    value_nm='iday_monthly'
    feature_df = gen_feature_df(data,key_word_nm,date_nm,value_nm,n,th)

    ###exploding_topic_list即為爆紅關鍵字
    #利用feature_df的特徵可以找出現在正在紅的關鍵字
    #以下2個rule
    #1.近peak_day_lag=30天有發生peak而且現在與最後峰斜率(now_slope)大於
    #2.現在就是peak的點(gap_peak==0)
    peak_day_lag = 30
    now_slope_threshold = -2
    exploding_topic_list = feature_df.loc[((feature_df.gap_peak<peak_day_lag)&(feature_df.now_slope>now_slope_threshold)) | \
                                           (feature_df.gap_peak==0),key_word_nm].tolist()

    ###similar_set相關性高的關鍵字
    #利用rate_0、rate_0_now篩選0太多的資料
    rate_0_threshold = 0.5
    corr_threshold = 0.7
    analysis_day = ['2021-05-01','2021-06-07']
    analysis_data = feature_df.loc[(feature_df.rate_0<rate_0_threshold)&(feature_df.rate_0_now<rate_0_threshold)]
    analysis_data = pd.merge(analysis_data,data,on=[key_word_nm])
    analysis_data = analysis_data.loc[(analysis_data[date_nm]>=analysis_day[0])&(analysis_data[date_nm]<analysis_day[1])]
    #similar_set中每一組list都是一組相關性高的關鍵字
    similar_set = gen_corr_set(analysis_data,key_word_nm,value_nm,corr_threshold)